﻿-- Initialization
RerollManager = LibStub("AceAddon-3.0"):NewAddon("RerollManager", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub('AceLocale-3.0'):GetLocale('RerollManager')
local LDB = LibStub("LibDataBroker-1.1", true)
local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)
local RMConfig = LibStub("AceConfig-3.0")
local RMConfigDialog = LibStub("AceConfigDialog-3.0")
local quixote = LibStub("LibQuixote-2.0")
local me = GetUnitName("Player").." - "..GetRealmName()

-- Database defaults
local DBDefault = {
	profile = {
		minimap = {
			hide = false,
		},
	},
	global = {
		[me] = {
			Fish = { done = -1, handle = true, },
			Cook = { done = -1, handle = true, },
			JC = { done = -1, handle = true, },
			Weekly = { done = -1, handle = true, },
			BG = { done = -1, handle = true, },
			Frost = { done = -1, handle = true, },
			ICC10 = { done = -1, handle = true, }, ICC25 = { done = -1, handle = true, },
			Archa10 = { done = -1, handle = true, }, Archa25 = { done = -1, handle = true, },
			EDC10 = { done = -1, handle = false, }, EDC25 = { done = -1, handle = false, }, EDC10H = { done = -1, handle = false, }, EDC25H = { done = -1, handle = false, }, 
			Uldu10 = { done = -1, handle = false, }, Uldu25 = { done = -1, handle = false, },
			Naxx10 = { done = -1, handle = false, }, Naxx25 = { done = -1, handle = false, },
			Ony10 = { done = -1, handle = false, }, Ony25 = { done = -1, handle = false, },
			Maly10 = { done = -1, handle = false, }, Maly25 = { done = -1, handle = false, },
			Sartha10 = { done = -1, handle = false, }, Sartha25 = { done = -1, handle = false, },
			Ruby10 = { done = -1, handle = false, }, Ruby25 = { done = -1, handle = false, },
		}
	},
}

-- Aweful globals variables needed :(
local weeklyResetTime
local listChars = { }

-- In order to associate rank with skill
local skillLocalizedNameByID = { Cook = 2550, Fish = 7620, JC = 25229 }
local skillRank = { Cook = -1, Fish = -1, JC = -1}

-- Main thing
local tasks = {
	ICC10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	ICC25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Archa10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Archa25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	EDC10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	EDC25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	EDC10H = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	EDC25H = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Uldu10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Uldu25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Naxx10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Naxx25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Ony10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Ony25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Maly10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Maly25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Sartha10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Sartha25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Ruby10 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Ruby25 = { done = -1, tipe = "raid", isDaily = false, levelRequire = 80, rankRequire = nil },
	Weekly = { done = -1, tipe = "misc", isDaily = false, levelRequire = 80, rankRequire = nil },
	Frost = { done = -1, tipe = "misc", isDaily = true, levelRequire = 70, rankRequire = nil },
	BG = { done = -1, tipe = "misc", isDaily = true, levelRequire = 80, rankRequire = nil },
	JC = { done = -1, tipe = "job", isDaily = true, levelRequire = 65, rankRequire = 350 },
	Fish = { done = -1, tipe = "job", isDaily = true, levelRequire = 70, rankRequire = nil },
	Cook = { done = -1, tipe = "job", isDaily = true, levelRequire = 65, rankRequire = 350 },
	}

--Quests
local questsList = {
	Fish = { 13830, 13832, 13833, 13834, 13836 },
	Cook = { 13100, 13101, 13102, 13103, 13107, 13112, 13113, 13114, 13115, 13116 },
	JC = { 12958, 12959, 12960, 12961, 12962, 12963 },
	Weekly = { 24579, 24580, 24581, 24582, 24583, 24584, 24585, 24586, 24587, 24588, 24589, 24590 }
}

-- Easier display in tt with this sort array
local taskList = {
	raids = { "ICC10", "ICC25", "Archa10", "Archa25", "EDC10", "EDC25", "EDC10H", "EDC25H", "Uldu10", "Uldu25", "Naxx10", "Naxx25", "Ony10", "Ony25",
	"Maly10", "Maly25", "Sartha10", "Sartha25", "Ruby10", "Ruby25" },
	jobs = { "JC", "Fish", "Cook" },
	misc = { "Weekly", "Frost", "BG" },
}

-- Let's go
function RerollManager:OnInitialize()
	-- Load SV // Register slash
	self:RegisterChatCommand("rm","SlashHandler")
	self:RegisterChatCommand("rerollmanager","SlashHandler")
	self.db = LibStub("AceDB-3.0"):New("RMdb", DBDefault)
	self:CreateMinimapFrame()
end

function RerollManager:OnEnable()
	-- Register events // hook funct // frames // init funct
	self:RegisterEvent("PLAYER_LOGOUT", "OnLogout") -- Hook raid ID if the player quit inside the instance
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "CheckIDs") -- Best way to check
	self:RegisterEvent("UPDATE_BATTLEFIELD_STATUS", "CheckBG") -- Seams to fire when bg is won
	self:RegisterEvent("LFG_COMPLETION_REWARD", "RequestLFGInfo") -- Fire at end of random
    self:RegisterEvent("LFG_UPDATE_RANDOM_INFO", "CheckFrost") -- Fire after updating the rewards
	quixote.RegisterCallback(RerollManager, "Quest_Abandoned")
	quixote.RegisterCallback(RerollManager, "Quest_Gained")
	quixote.RegisterCallback(RerollManager, "Quest_Lost")
	self:ScheduleTimer("LoadSV",GetQuestResetTime()+60) -- In case of :o
	self:ScheduleTimer("Loading", 1) -- Skills rank aren't requestable on PLAYER_LOGIN, need to wait (WTF blizz ?)
end

function RerollManager:Loading()
	self:LocalizeSkillName()
	self:GetSkillRank()
	self:CheckLevel()
	self:LoadSV()
	self:CheckQuest()
	self:CheckIDs()
	self:CheckBG()
	self:CheckFrost()
	RMConfig:RegisterOptionsTable("RerollManager", RerollManager:Options())
	RMConfigDialog:AddToBlizOptions("RerollManager", "RerollManager")
end

--- FUNCTIONS
function RerollManager:SlashHandler(msg)
	if msg == "hide" then
		self.db.profile.minimap.hide = not self.db.profile.minimap.hide
		if self.db.profile.minimap.hide then
			LDBIcon:Hide("RerollManager")
			self:Printf("%s.",L.SlashCmdHidden)
		else
			LDBIcon:Show("RerollManager")
			self:Printf("%s.",L.SlashCmdShown)
		end
	elseif msg == "list" then
		local i = 1
		for k,v in pairs(self.db.global) do
			listChars[i] = k
			self:Printf("%s - %s",i,k)
			i = i+1
		end
	elseif string.find(msg,"del") then
		local num = tonumber(string.match(msg,"%d+"))
		if num and listChars[num] then
			self:Printf("%s %s - %s. %s.",L.SlashCmdDeleting,num,listChars[num],L.SlashCmdWiped)
			wipe(self.db.global[listChars[num]])
		elseif num then
			self:Printf("%s %s %s.",L.SlashCmdChar,num,L.SlashCmdNExist)
		end
	else
		self:Printf("%s :",L.SlashCmdHelp)
		self:Printf("/rm list :: %s",L.SlashCmdList)
		self:Printf("/rm del # :: %s",L.SlashCmdDelete)
		self:Printf("/rm hide :: %s",L.SlashCmdHide)
	end
end

-- Callbacks
function RerollManager:Quest_Abandoned(event, name, uid)
	for tipe,_ in pairs(questsList) do
		for k,id in pairs(questsList[tipe]) do
			if (uid == id) then
				self:SetDone(tipe,0)
			end
		end
	end
end

function RerollManager:Quest_Gained(event, name, uid)
	for tipe,_ in pairs(questsList) do
		for k,id in pairs(questsList[tipe]) do
			if (uid == id) then
				self:SetDone(tipe,1)
			end
		end
	end
end

function RerollManager:Quest_Lost(event, name, uid)
	for tipe,_ in pairs(questsList) do
		for k,id in pairs(questsList[tipe]) do
			if (uid == id) then
				if (self:GetStatus(tipe) == 1) then
					if not tipe == "Weekly" then self:SetDone(tipe,2,GetQuestResetTime()) else self:SetDone(tipe,2,weeklyResetTime) end
				end
			end
		end
	end
end

-- Public methods of the tasks
function RerollManager:SetDone(task, number, reset)
	tasks[task].done = number
	self.db.global[me][task].done = number
	if reset then -- if reset param
		if reset < time() then -- adaptative reset timer set
			self.db.global[me][task].reset = time() + reset
		else
			self.db.global[me][task].reset = reset
		end
	end
end

function RerollManager:SetZero(task)
	tasks[task].done = 0
	if self.db.global[me][task].done == -1 then self.db.global[me][task].done = 0 end 
end

function RerollManager:GetStatus(task)
	if tasks[task] then
		return tasks[task].done
	end
end

-- Lots of checking functions
function RerollManager:CheckLevel()
	local lvl = UnitLevel("player")
	for k,_ in pairs(tasks) do
		if lvl >= tasks[k].levelRequire then
			if not tasks[k].rankRequire or skillRank[k] >= tasks[k].rankRequire then
				self:SetZero(k)
			end
		end
	end
end

function RerollManager:CheckIDs()
	local numInstances = GetNumSavedInstances()
	for i = 1, numInstances do
		local name, id, reset, difficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName = GetSavedInstanceInfo(i)
		name = name.." "..maxPlayers
		if isRaid then
			for k,v in pairs(tasks) do
				if tasks[k].tipe == "raid" and name == L[k] then
					if difficulty == 4 then
						if locked then self:SetDone(k.."H", 2, reset) else self:SetDone(k.."H", 0) end
					else
						if locked then self:SetDone(k, 2, reset) else self:SetDone(k,0) end
					end
					if locked then weeklyResetTime = reset + time() end
				end
			end
		end
	end
end

function RerollManager:RequestLFGInfo()
	RequestLFDPlayerLockInfo()
end

function RerollManager:CheckFrost()
	if self:GetStatus("Frost") ~= -1 then
		local doneToday
		if UnitLevel("player") == 80 then
			doneToday = GetLFGDungeonRewards(262) --WotLK randomH
		else
			doneToday = GetLFGDungeonRewards(261)
		end
		if doneToday then self:SetDone("Frost",2,GetQuestResetTime()) else self:SetDone("Frost",0) end
	end
end

function RerollManager:CheckBG()
	if self:GetStatus("BG") ~= -1 then
		local hasWinHoliday = GetHolidayBGHonorCurrencyBonuses()
		local hasWinRandom = GetRandomBGHonorCurrencyBonuses()
		if hasWinHoliday or hasWinRandom then self:SetDone("BG",2,GetQuestResetTime()) else self:SetDone("BG",0) end
	end
end

function RerollManager:CheckQuest()
	for k,_ in pairs(questsList) do
		if self:GetStatus(k) == 0 then
			if self:ScanQuestLog(questsList[k]) then self:SetDone(k,1) end
		end
	end
end

function RerollManager:ScanQuestLog(ids)
	local i = 1
	while GetQuestLogTitle(i) do
		local _, _, _, _, _, _, _, _, questID = GetQuestLogTitle(i)
		if (tContains(ids, questID)) then return true end
		i = i + 1
	end
	return false
end

function RerollManager:LocalizeSkillName()
	for k,v in pairs(skillLocalizedNameByID) do
		skillLocalizedNameByID[k] = GetSpellInfo(v)
	end
end

function RerollManager:GetSkillRank()
	local numSkills = GetNumSkillLines()
	for i=1, numSkills do
		local skillName, isHeader, _, skillRankInfo = GetSkillLineInfo(i)
		if not isHeader then
			for k,v in pairs(skillLocalizedNameByID) do
				if v == skillName then skillRank[k] = skillRankInfo end
			end
		end
	end
end

-- Loading saved variables and checking for dailies/weekly expiry
function RerollManager:LoadSV()
	if self.db.char then wipe(self.db.char) end
	if (self.db.global) then
		for k1,v1 in pairs(self.db.global) do -- k1 == list of chars
			for k2,v2 in pairs(v1) do -- k2 == list of tasks
				local dbDate, dbDone, dbReset
				for k3,v3 in pairs(v2) do -- k3 == status
					if k3 == "done" then dbDone = v3
					elseif k3 == "reset" then dbReset = v3
					end
				end
				
				if dbDone and dbDone == 2 then
					if not dbReset then
						if tasks[k2].isDaily then dbReset = GetQuestResetTime() else dbReset = weeklyResetTime end
					end
					
					if k1 == me then
						if dbReset < time() then self:SetDone(k2,0) else self:SetDone(k2,2,GetQuestResetTime()) end
					else
						if dbReset < time() then self.db.global[k1][k2].done = 0 end
					end
				end
			end
		end
	end
end

-- Minimap tooltip functions
function RerollManager:ttformat(text,done)
	if text then
		if done == 0 then
			return "|cFFFF0000"..text.."|r"
		elseif done == 1 then
			return text
		elseif done == 2 then
			return "|cFF00FF00"..text.."|r"
		end
	end
	return ""
end

function RerollManager:CreateMinimapFrame()
	if LDB then
		local numPersoSelectionne
		local alt = me
		local listePerso = { }
		local i = 1
		if (self.db.global) then
			for k,v in pairs(self.db.global) do
				listePerso[i] = k
				if k == me then numPersoSelectionne = i end
				i = i + 1
			end
		end
		if numPersoSelectionne == nil then listePerso[i] = self.db:GetCurrentProfile() numPersoSelectionne = i end

		local function OnLDBClick(frame, btn)
			if btn == "LeftButton" then
				numPersoSelectionne = numPersoSelectionne + 1
				if numPersoSelectionne > #listePerso then numPersoSelectionne = 1 end
				alt = listePerso[numPersoSelectionne]
			else
				InterfaceOptionsFrame_OpenToCategory("RerollManager")
			end
		end
		
		local function OnLDBShowTooltip(tt)
			tt:AddLine("RerollManager :: Recap")
			if alt == me then
				tt:AddLine("|cFFFFFFFF"..L.RaidIDs.."|r")
				for k,v in pairs(taskList.raids) do
					if self.db.global[alt][v].handle then tt:AddLine(self:ttformat(L[v],self:GetStatus(v))) end
				end
				tt:AddLine(" ")
				tt:AddLine("|cFFFFFFFF"..L.JobQuests.."|r")
				for k,v in pairs(taskList.jobs) do
					if self.db.global[alt][v].handle then tt:AddLine(self:ttformat(L[v],self:GetStatus(v))) end
				end
				tt:AddLine(" ")
				tt:AddLine("|cFFFFFFFF"..L.Misc.."|r")
				for k,v in pairs(taskList.misc) do
					if self.db.global[alt][v].handle then tt:AddLine(self:ttformat(L[v],self:GetStatus(v))) end
				end
			else
				tt:AddLine(alt)
				tt:AddLine("|cFFFFFFFF"..L.RaidIDs.."|r")
				for k,v in pairs(taskList.raids) do
					if self.db.global[alt][v] and (self.db.global[alt][v].handle or (self.db.global[alt][v].handle == nil and DBDefault.global[me][v].handle)) then tt:AddLine(self:ttformat(L[v],self.db.global[alt][v].done)) end
				end
				tt:AddLine(" ")
				tt:AddLine("|cFFFFFFFF"..L.JobQuests.."|r")
				for k,v in pairs(taskList.jobs) do
					if self.db.global[alt][v] and (self.db.global[alt][v].handle or (self.db.global[alt][v].handle == nil and DBDefault.global[me][v].handle)) then tt:AddLine(self:ttformat(L[v],self.db.global[alt][v].done)) end
				end
				tt:AddLine(" ")
				tt:AddLine("|cFFFFFFFF"..L.Misc.."|r")
				for k,v in pairs(taskList.misc) do
					if self.db.global[alt][v] and (self.db.global[alt][v].handle or (self.db.global[alt][v].handle == nil and DBDefault.global[me][v].handle)) then tt:AddLine(self:ttformat(L[v],self.db.global[alt][v].done)) end
				end
			end
		end
		
        local RerollManagerLauncher = LDB:NewDataObject("RerollManager", {
            tipe = "launcher",
            icon = "Interface\\Icons\\SPELL_nature_invisibilty",
            OnClick = function(clickedframe, button)
				GameTooltip:ClearLines()
				OnLDBClick(clickedframe, button)
				OnLDBShowTooltip(GameTooltip)
				GameTooltip:Show()
            end,
            OnTooltipShow = function(tt)
				OnLDBShowTooltip(tt)
			end
        })
		
        if LDBIcon then
            LDBIcon:Register("RerollManager", RerollManagerLauncher, self.db.profile.minimap)
		end
	end
end

-- And to finish, the flyboats
function RerollManager:OnLogout()
	self:CheckIDs()
end